// ============================================================================================
// This entire partial class is dependent on the SHOWPARAMETERS conditional compilation symbol.
// ============================================================================================
#if SHOWPARAMETERS
using System;
using PHS.Forms;
namespace PHS
{
    public partial class Methods
    {
        private static void DisplayRuntimeExecuteParameters(Int32 window, string variables, string statement, Int32 callback, Int32 returnValue, string updatedVariables, bool firstIteration)
        {
            DebugForm df = new DebugForm();
            df.MessageListbox.Items.Add("========== RunTimeExecute parameters ==========");
            df.MessageListbox.Items.Add(string.Format("window (Int32) = {0}", window));
            if(variables == null)
            {
                df.MessageListbox.Items.Add("variables (string) = null");
            }
            else if(variables.Length == 0)
            {
                df.MessageListbox.Items.Add("variables (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("variables (string) length {0} = {1}", variables.Length, variables));
            }
            if(statement == null)
            {
                df.MessageListbox.Items.Add("statement (string) = null");
            }
            else if(statement.Length == 0)
            {
                df.MessageListbox.Items.Add("statement (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("statement (string) length {0} = {1}", statement.Length, statement));
            }
            df.MessageListbox.Items.Add(string.Format("callback (Int32) = {0}", callback));
            df.MessageListbox.Items.Add(string.Format("returnValue (Int32) = {0}", returnValue));
            if(updatedVariables == null)
            {
                df.MessageListbox.Items.Add("updatedVariables (string) = null");
            }
            else if(updatedVariables.Length == 0)
            {
                df.MessageListbox.Items.Add("updatedVariables (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("updatedVariables (string) length {0} = {1}", updatedVariables.Length, updatedVariables));
            }
            df.MessageListbox.Items.Add(string.Format("firstIteration (bool) = {0}", firstIteration));
            df.ShowDialog();
        }

        private static void DisplayDesignTimeEditParameters(uint window, string statement, string newStatement, bool displayDialog)
        {
            DebugForm df = new DebugForm();
            df.MessageListbox.Items.Add("========== DesignTimeEdit parameters ==========");
            df.MessageListbox.Items.Add(string.Format("window (uint) = {0}", window));
            if(statement == null)
            {
                df.MessageListbox.Items.Add("statement (string) = null");
            }
            else if(statement.Length == 0)
            {
                df.MessageListbox.Items.Add("statement (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("statement (string) length {0} = {1}", statement.Length, statement));
            }
            if(newStatement == null)
            {
                df.MessageListbox.Items.Add("newStatement (string) = null");
            }
            else if(newStatement.Length == 0)
            {
                df.MessageListbox.Items.Add("newStatement (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("newStatement (string) length {0} = {1}", newStatement.Length, newStatement));
            }
            df.MessageListbox.Items.Add(string.Format("displayDialog (bool) = {0}", displayDialog));
            df.ShowDialog();
        }

        private static void DisplayDesignTimeTextParameters(string statement, string text)
        {
            DebugForm df = new DebugForm();
            df.MessageListbox.Items.Add("========== DesignTimeText parameters ==========");
            if(statement == null)
            {
                df.MessageListbox.Items.Add("statement (string) = null");
            }
            else if(statement.Length == 0)
            {
                df.MessageListbox.Items.Add("statement (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("statement (string) length {0} = {1}", statement.Length, statement));
            }
            if(text == null)
            {
                df.MessageListbox.Items.Add("text (string) = null");
            }
            else if(text.Length == 0)
            {
                df.MessageListbox.Items.Add("text (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("text (string) length {0} = {1}", text.Length, text));
            }
            df.ShowDialog();
        }

        private static void DisplayCompileTimeBuildParameters(string moduleFolder, Int32 msiHandle, string state, string buildPath, bool build, string fetch)
        {
            DebugForm df = new DebugForm();
            df.MessageListbox.Items.Add("========== CompileTimeBuild parameters ==========");
            if(moduleFolder == null)
            {
                df.MessageListbox.Items.Add("moduleFolder (string) = null");
            }
            else if(moduleFolder.Length == 0)
            {
                df.MessageListbox.Items.Add("moduleFolder (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("moduleFolder (string) length {0} = {1}", moduleFolder.Length, moduleFolder));
            }
            df.MessageListbox.Items.Add(string.Format("msiHandle (Int32) = {0}", msiHandle));
            if(state == null)
            {
                df.MessageListbox.Items.Add("state (string) = null");
            }
            else if(state.Length == 0)
            {
                df.MessageListbox.Items.Add("state (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("state (string) length {0} = {1}", state.Length, state));
            }
            if(buildPath == null)
            {
                df.MessageListbox.Items.Add("buildPath (string) = null");
            }
            else if(buildPath.Length == 0)
            {
                df.MessageListbox.Items.Add("buildPath (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("buildPath (string) length {0} = {1}", buildPath.Length, buildPath));
            }
            df.MessageListbox.Items.Add(string.Format("build (bool) = {0}", build));
            if(fetch == null)
            {
                df.MessageListbox.Items.Add("fetch (string) = null");
            }
            else if(buildPath.Length == 0)
            {
                df.MessageListbox.Items.Add("fetch (string) = The length of this parameter is zero. There is no data to display.");
            }
            else
            {
                df.MessageListbox.Items.Add(string.Format("fetch (string) length {0} = {1}", fetch.Length, fetch));
            }
            df.ShowDialog();
        }
    }
}
#endif